// CRC.hpp  declarations for class CRC
// last updated by Roedy Green on 1996 November 5

/*
Roedy Green
Canadian Mind Products
#208 - 525 Ninth Street
New Westminster BC Canada
V5H 2N6
tel:(604) 777-1804
mailto:roedy@mindprod.com
http://mindprod.com
*/

class CRC
  {
  /* calculate 16-bit checksums  */
public:

  CRC(void) { work = 0;}

  ~CRC() {}

  WORD Result(void) { return work;}

  void Reset(void) { work = 0;}

  void Append( BYTE *String, WORD Length );

  static int InitCRCTable(WORD Poly = 0x8408);
  /* usually we would use Poly = 0x8408, the 16-bit CCITT polynomial.
     build lookup table to help compute the CRC function.
               Only needs be called once. */

protected:

  static WORD CRCTable[256];
  /* magic numbers used to compute CRC .
     table of constants.  Only one copy needed */

  WORD work;
  /* where we accumulate the crc */

  };

/* ***************************************** */
// -30-

